package uibk.applets.statistik;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import uibk.mtk.math.functions.Function1D;
import uibk.mtk.math.functions.Function2D;
import javax.swing.JRadioButton;

import uibk.mtk.swing.base.DoubleTextField;



/**
 * Klasse zum Auswertung der Benutzereingaben Berechnunge des Pendels und des
 * Plots (ist ActionListener fr den Panel <CODE>PanelCommand</CODE>)
 * 
 * <p>
 * Copyright: Institut fr Technische Mathematik, Geometrie und Bauinformatik,
 * 2006
 * </p>
 * 
 * @author Andreas Rudigier (csae7164@uibk.ac.at)
 */
public class InteractionControl implements ActionListener {

	/** Erzeugt Interactioncontrol */
	public InteractionControl(AppletStatistik main, PanelCommand panelcommand) {
		this.main = main;
		this.panelcommand = panelcommand;
	}


	/** Ereignisverarbeitung: Start, Stopp, Neu und Art der Schwingung */
	public void actionPerformed(ActionEvent ev) {
	if (ev.getActionCommand().equals("symm")) {
		visible();
		}
		if (ev.getActionCommand().equals("asymm")) {
			visible();
		}
		if (ev.getActionCommand().equals("fenster")) {
			visible();
		}
		if (ev.getActionCommand().equals("fenstereins")) {
			visible();
		}
		if (ev.getActionCommand().equals("zeichnen")) {
			int n=main.verteilung;
			if (n==1||n==2||n==3) {
				main.axescube3d.setVisible(false);
				main.mathpanel3d.setVisible(false);
				main.mathpanel2d.setVisible(true);
				main.setMainPanel(main.mathpanel2d);
				//Lschen der 3D Flche
				main.surface3d.setMesh(null);
				main.graph.clearpoints();
				main.graphdiskret.setVisible(true);
				try {
					if (n!=2) {
						main.stat.calcplotdiskret(null, main.paneldefverteilung.start,
								main.stat.getint());
					} else {
						main.stat.calcplotdiskret(null, main.paneldefverteilung.start,
								main.stat.getintt(4));
					}
					} catch (Exception e) {
						return;
					}
			}
			if (n==4||n==5||n==7||n==8||n==9||n==10||n==11) {
				main.axescube3d.setVisible(false);
				main.mathpanel3d.setVisible(false);
				//Lschen der 3D Flche
				main.surface3d.setMesh(null);
				main.mathpanel2d.setVisible(true);
				main.setMainPanel(main.mathpanel2d);
				main.graph.setVisible(true);
				main.graphdiskret.clear();
				try {
					Function1D funk=main.stat.getkont();
					main.stat.getlimits(funk);
					main.stat.calcplotkont2dim(funk,main.start,main.ende);
				} catch (Exception e) {
					return;
				}
			}
			if (n==6) {
				main.axescube3d.setVisible(true);
				main.mathpanel3d.setVisible(true);
				main.surface3d.setVisible(true);
				main.setMainPanel(main.mathpanel3d);
				main.mathpanel2d.setVisible(false);
				main.graphdiskret.clear();
				main.graph.clearpoints();
				try {
					Function2D funk=main.stat.getkont2D();
					main.stat.calcplotkont3dim(funk);
				} catch (Exception e) {
					return;
				}
			}
		}
	}
	private void visible(){
		DoubleTextField[]quant=main.paneldefverteilung.quant;
		JRadioButton[]quantil=main.paneldefverteilung.quantil;
		quant[0].setEnabled(quantil[0].isSelected());
		quant[1].setEnabled(quantil[1].isSelected());
		quant[2].setEnabled(quantil[1].isSelected());
		quant[3].setEnabled(quantil[2].isSelected());
		quant[4].setEnabled(quantil[2].isSelected());
		quant[5].setEnabled(quantil[3].isSelected());
		quant[6].setEnabled(quantil[3].isSelected());
	}

	/** Referenz auf die Hauptklasse */
	AppletStatistik main;

	/** Referenz auf den Panel mit den Eingabefeldern */
	PanelCommand panelcommand;

}
