package uibk.applets.statistik;

import java.awt.Color;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JTabbedPane;



import uibk.mtk.lang.Messages;
import uibk.mtk.swing.base.MPanel;
import uibk.mtk.swing.scene3d.PanelAxes3DStyle;
import uibk.mtk.swing.scene3d.PanelColoring;
import uibk.mtk.swing.scene3d.PanelScale3D;
import uibk.mtk.swing.scene3d.PanelShading;
import uibk.mtk.swing.scene3d.PanelSurface3DStyle;
import uibk.mtk.swing.scene3d.PanelView3D;
import uibk.mtk.swing.scene3d.PanelRendering;


/**
 * Panel zum Steuern des Applets
 * 
 * <p>
 * Copyright: Institut fr Grundlagen der Bauingenieurswissenschaften,
 * 2006
 * </p>
 * 
 * @author Rudigier Andreas (csae7164@uibk.ac.at)
 */
class PanelCommand extends MPanel {
	
	/** Ereignisverarbeitung */
	InteractionControl control;
	
	AppletStatistik main;


	public PanelCommand(AppletStatistik main) {

		this.main = main;
		initComponents();

	}

	/** Initialisieren der Komponenten */
	void initComponents() {
		//Layout und Rahmen
		setBorder(BorderFactory.createLineBorder(Color.black));
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		InteractionControl control = new InteractionControl(main, this);

		MPanel tab1 = new MPanel();
		MPanel tab2 = new MPanel();
		MPanel tab3 = new MPanel();
		MPanel tab4 = new MPanel();

		//Erzeugen der Panel zur Eingabe Fkt. 
		main.paneldefverteilung = new PanelDefVerteilung(main,control);
		tab1.setLayout(new BoxLayout(tab1, BoxLayout.Y_AXIS));
		tab2.setLayout(new BoxLayout(tab2, BoxLayout.Y_AXIS));
		tab3.setLayout(new BoxLayout(tab3, BoxLayout.Y_AXIS));
		tab4.setLayout(new BoxLayout(tab4, BoxLayout.Y_AXIS));
		
		//Panel zum Erzeugen der Verteilungen
		tab1.add(main.paneldefverteilung.PanelDefVert());
		tab1.add(main.paneldefverteilung.panelparam());
		tab1.add(main.paneldefverteilung.panelquant());
		tab1.add(main.paneldefverteilung.panelzeichnen());
		//Panel fr Projektionsoptionen, zum Skalieren
		tab2.add(new PanelView3D(main.mathpanel3d));
		tab3.add(new PanelScale3D(main.mathpanel3d));
		tab3.add(new PanelAxes3DStyle(main.axescube3d, main.mathpanel3d));
		tab4.add(new PanelSurface3DStyle(main.surface3d, main.mathpanel3d));
		tab4.add(new PanelShading(main.mathpanel3d));
		tab4.add(new PanelColoring(main.mathpanel3d, main.surface3d));
		tab4.add(new PanelRendering(main.mathpanel3d));
		//Erzeugen eines Panels mit Reitern
		JTabbedPane tabbedpane = new JTabbedPane();

		tabbedpane
				.addTab(
						Messages.getString(AppletStatistik.BUNDLE_NAME,
								"PanelCommand.0"), null, tab1, Messages.getString(AppletStatistik.BUNDLE_NAME, "PanelCommand.1")); //$NON-NLS-1$ //$NON-NLS-2$
		tabbedpane
				.addTab(
						Messages.getString(AppletStatistik.BUNDLE_NAME,
								"PanelCommand.2"), null, tab2, Messages.getString(AppletStatistik.BUNDLE_NAME, "PanelCommand.3")); //$NON-NLS-1$ //$NON-NLS-2$
		tabbedpane.addTab(Messages.getString(AppletStatistik.BUNDLE_NAME,
				"PanelCommand.4"), //$NON-NLS-1$
				null, tab3, Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelCommand.5")); //$NON-NLS-1$
		tabbedpane.addTab(Messages.getString(AppletStatistik.BUNDLE_NAME,
		"PanelCommand.6"), //$NON-NLS-1$
		null, tab4, Messages.getString(AppletStatistik.BUNDLE_NAME,
				"PanelCommand.7")); //$NON-NLS-1$
		add(tabbedpane);
	}


}