package uibk.applets.statistik;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;

import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JSlider;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import uibk.mtk.lang.Messages;
import uibk.mtk.swing.appletbase.PanelLoadExample;
import uibk.mtk.swing.base.Button;
import uibk.mtk.swing.base.DoubleTextField;
import uibk.mtk.swing.base.IntervalTextField;
import uibk.mtk.swing.base.MPanel;
import uibk.mtk.swing.base.IntegerTextField;
import uibk.mtk.swing.base.Label;

import uibk.mtk.swing.base.*;

/**
 * Panel zum Eingeben und Zeichnen der Verteilung
 * 
 * <p>
 * Copyright: Institut fr Grundlagen der Bauingenieurswissenschaften 2006
 * </p>
 * 
 * @author Rudigier Andreas (csae7164@uibk.ac.at)
 */

public class PanelDefVerteilung {

	/** Verknpfung mit Main */
	AppletStatistik main;

	/** Verknpfung mit Interaction */
	InteractionControl control;

	/** Textfeld fr die Charakteristiken */
	DoubleTextField[] text = new DoubleTextField[11];

	/** Textfeld fr die Freiheitsgrade */
	IntegerTextField[] textint = new IntegerTextField[5];

	/** Textfeld fr die Darstellung */
	DoubleTextField[] quant = new DoubleTextField[7];

	/** Textfeld fr die Darstellung der diskreten Verteilungen */
	IntegerTextField anz;

	/** Labels fr die Anzahl */
	Label labelanz;

	/** Labels fr die Quantile */
	Label[] labelquant = new Label[6];

	/** String fr der diskreten Verteilungen */
	String disk;

	/** Option der Berechnung der Quantile */
	JRadioButton[] quantil = new JRadioButton[4];

	/** Labels fr die Charakteristiken */
	Label[][] label = new Label[10][3];

	/** minimal zu zeichnente Anzahl bei diskreten Verteilungen */
	static final Integer Min = new Integer("1"); //$NON-NLS-1$

	/** maximal zu zeichnente Anzahl bei diskreten Verteilungen */
	static final Integer Max = new Integer("170"); //$NON-NLS-1$

	/** Start der diskreten Verteilung */
	int start = 1;

	/** Slider zur Anpassung der Gre des Gitters */
	JSlider sliderMeshPoints;

	/** Label mit der aktuellen Gre des Gitters */
	JLabel labelmesh;

	/** Textfeld fr den Bereich die x Achse */
	IntervalTextField txtIntervalx;

	/** Textfeld fr den Bereich die y Achse */
	IntervalTextField txtIntervaly;

	/** Label fr den Bereich die x Achse */
	JLabel xAchse = new JLabel("x-Achse");

	/** Label fr den Bereich die y Achse */
	JLabel yAchse = new JLabel("y-Achse");

	public PanelDefVerteilung(AppletStatistik main, InteractionControl control) {
		this.main = main;
		this.control = control;

		anz = new IntegerTextField(10, Min, Max, Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelDef.31"));
		anz.setActionCommand("anzahl"); //$NON-NLS-1$
		anz.addActionListener(control);
		anz.setText("10");
		anz.setToolTipText(Messages.getString(AppletStatistik.BUNDLE_NAME,
				"PanelDef.32")); //$NON-NLS-1$
		anz.setVisible(false);

		label[0][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.1"));
		label[0][0].setPreferredSize(new Dimension(120, 20));
		label[1][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.2"));
		label[1][0].setPreferredSize(new Dimension(120, 20));
		label[1][1] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.2.5"));
		label[1][1].setPreferredSize(new Dimension(120, 20));
		label[2][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.3"));
		label[2][0].setPreferredSize(new Dimension(120, 20));
		label[3][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.4"));
		label[3][0].setPreferredSize(new Dimension(120, 20));
		label[3][1] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.5"));
		label[3][1].setPreferredSize(new Dimension(120, 20));
		label[4][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.6"));
		label[4][0].setPreferredSize(new Dimension(120, 20));
		label[5][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.8"));
		label[5][0].setPreferredSize(new Dimension(120, 20));
		label[5][1] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.9"));
		label[5][1].setPreferredSize(new Dimension(120, 20));
		label[5][2] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.10"));
		label[5][2].setPreferredSize(new Dimension(120, 20));
		label[6][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.11"));
		label[6][0].setPreferredSize(new Dimension(120, 20));
		label[6][1] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.12"));
		label[6][1].setPreferredSize(new Dimension(120, 20));
		label[7][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.13"));
		label[7][0].setPreferredSize(new Dimension(120, 20));
		label[8][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.14"));
		label[8][0].setPreferredSize(new Dimension(120, 20));
		label[9][0] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.15"));
		label[9][0].setPreferredSize(new Dimension(120, 20));
		label[9][1] = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.16"));
		label[9][1].setPreferredSize(new Dimension(120, 20));
		labelanz = new Label(Messages.getString(
				"uibk.applets.statistik.messages", "Label.17"));
		labelanz.setPreferredSize(new Dimension(120, 20));
		labelanz.setVisible(false);

		Font f = new Font("Serif", Font.PLAIN, 14);

		for (int i = 0; i < 10; i++) {
			for (int j = 0; j < 2; j++) {
				if (label[i][j] != null)
					label[i][j].setFont(f);
			}
		}
	}

	public MPanel PanelDefVert() {

		String options[] = {
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.40"),
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.41"),
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.42"),
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.43"),
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.44"),
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.45"),
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.46"),
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.47"),
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.48"),
				Messages.getString("uibk.applets.statistik.messages",
						"PanelLoad.49") };
		// LoadAction die beim Auswhlen eines Elementes der Auswahlbox
		// ausgefhrt wird hinzufgen
		PanelLoadExample.LoadAction action = new PanelLoadExample.LoadAction() {

			public void execute(String item) {
				visible(main.verteilung, false);

				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.40"))) {
					main.verteilung = 1;
					main.symm = 3;
					main.paneldefverteilung.start = 0;
					text[0].setText("0.5");
					visible(main.verteilung, true);
				}
				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.41"))) {
					main.verteilung = 2;
					main.symm = 2;
					text[1].setText("0.5");
					textint[4].setText("10");
					main.paneldefverteilung.start = 0;
					visible(main.verteilung, true);

				}
				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.42"))) {
					main.verteilung = 3;
					main.symm = 3;
					text[2].setText("1");
					main.paneldefverteilung.start = 0;
					visible(main.verteilung, true);

				}
				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.43"))) {
					main.verteilung = 4;
					main.symm = 6;
					text[3].setText("2");
					text[4].setText("2");
					visible(main.verteilung, true);
				}
				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.44"))) {
					main.verteilung = 5;
					main.symm = 1;
					text[5].setText("1");
					quant[0].setText("0.999999");
					visible(main.verteilung, true);
				}
				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.45"))) {
					main.verteilung = 6;
					main.symm = 5;
					text[6].setText("1");
					text[7].setText("1");
					text[8].setText("0");
					txtIntervalx.setText("[-4,4]");
					txtIntervaly.setText("[-4,4]");
					visible(main.verteilung, true);
				}
				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.46"))) {
					main.verteilung = 7;
					main.symm = 4;
					text[9].setText("0");
					text[10].setText("1");
					quant[0].setText("0.999999");
					visible(main.verteilung, true);
				}
				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.47"))) {
					main.verteilung = 8;
					main.symm = 4;
					textint[0].setText("5");
					quant[0].setText("0.999999");
					visible(main.verteilung, true);
				}
				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.48"))) {
					main.verteilung = 9;
					main.symm = 1;
					textint[1].setText("5");
					quant[0].setText("0.99999");
					visible(main.verteilung, true);
				}
				if (item.equals(Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelLoad.49"))) {
					main.verteilung = 10;
					main.symm = 4;
					textint[2].setText("5");
					textint[3].setText("10");
					quant[0].setText("0.99999");
					visible(main.verteilung, true);
				}
				visiblesymm();
			}
		};
		uibk.mtk.swing.appletbase.PanelLoadExample.LoadAction actions[] = {
				action, action, action, action, action, action, action, action,
				action, action };
		return new PanelLoadExample(Messages.getString(
				"uibk.applets.statistik.messages", "PanelLoad.50"), Messages
				.getString("uibk.applets.statistik.messages", "PanelLoad.51"),
				options, actions);
	}

	public TitledPanel panelparam() {
		String charak = new String("Charakteristik");
		TitledPanel panelDarstel = new TitledPanel(charak);

		// Rahmen
		TitledBorder b = BorderFactory.createTitledBorder(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.1"));
		b.setTitleFont(b.getTitleFont().deriveFont(1));

		// Layout
		panelDarstel.setBorder(b);
		panelDarstel.setLayout(new GridBagLayout());
		panelDarstel.setMaximumSize(new Dimension(500, 100));

		/** die Daten der Eingabe der Parameter der Schwingung */
		Boolean positiv[] = new Boolean[11];
		positiv = (new Boolean[] { null, null, Boolean.TRUE, Boolean.TRUE,
				Boolean.TRUE, Boolean.TRUE, Boolean.TRUE, Boolean.TRUE, null,
				null, Boolean.TRUE });

		Double[] right = { new Double(1), new Double(1), null, null, null,
				null, null, null, new Double(1), null, null };

		Double[] left = { new Double(0), new Double(0), null, null, null, null,
				null, null, new Double(0), null, null };

		for (int i = 0; i < 11; i++) {
			text[i] = new DoubleTextField(6, left[i], right[i], positiv[i],
					Messages.getString("uibk.applets.statistik.messages",
							"PanelDef.".concat(Integer.toString(i + 40))));
			text[i].setText("0");
			text[i].setActionCommand("text".concat(Integer.toString(i + 1)));
			text[i].addActionListener(control);
		}

		for (int i = 0; i < 5; i++) {
			textint[i] = new IntegerTextField(10, Min, Max, Messages.getString(
					AppletStatistik.BUNDLE_NAME, "PanelDef.32"));
			textint[i].setText("0");
			textint[i]
					.setActionCommand("text".concat(Integer.toString(i + 11)));
			textint[i].addActionListener(control);

		}

		for (int i = 1; i < 11; i++) {
			visible(i, false);
		}

		panelDarstel
				.add(text[0], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[1], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[2], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[3], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[4], new GridBagConstraints(1, 1, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[5], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[6], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[7], new GridBagConstraints(1, 1, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[8], new GridBagConstraints(1, 2, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[9], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(text[10], new GridBagConstraints(1, 1, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(textint[0], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(textint[1], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(textint[2], new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(textint[3], new GridBagConstraints(1, 1, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(textint[4], new GridBagConstraints(1, 1, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));

		panelDarstel
				.add(label[0][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 0, 0), 0, 0));
		panelDarstel
				.add(label[1][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 0, 0), 0, 0));
		panelDarstel
				.add(label[1][1], new GridBagConstraints(0, 1, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 0, 0), 0, 0));
		panelDarstel
				.add(label[2][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 0, 0), 0, 0));
		panelDarstel
				.add(label[3][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 0, 0), 0, 0));
		panelDarstel
				.add(label[3][1], new GridBagConstraints(0, 1, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[4][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[5][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[5][1], new GridBagConstraints(0, 1, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[5][2], new GridBagConstraints(0, 2, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[6][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[6][1], new GridBagConstraints(0, 1, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[7][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[8][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[9][0], new GridBagConstraints(0, 0, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(label[9][1], new GridBagConstraints(0, 1, 1, 1, 0.0D,
						0.0D, GridBagConstraints.EAST, 0,
						new Insets(0, 0, 5, 0), 0, 0));

		return panelDarstel;
	}

	public TitledPanel panelquant() {
		String charak = new String("Darstellung");
		TitledPanel panelDarstel = new TitledPanel(charak);

		// Rahmen
		TitledBorder b = BorderFactory.createTitledBorder(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.8"));
		b.setTitleFont(b.getTitleFont().deriveFont(1));

		// Layout
		panelDarstel.setBorder(b);
		panelDarstel.setLayout(new GridBagLayout());
		panelDarstel.setMaximumSize(new Dimension(620, 250));
		for (int i = 0; i < 6; i++) {
			labelquant[i] = new Label(Messages.getString(
					"uibk.applets.statistik.messages", "Label.".concat(Integer
							.toString(18 + i))));
			labelquant[i].setPreferredSize(new Dimension(120, 20));
		}

		quant[0] = new DoubleTextField(6, new Double(0.001), new Double(0.999),
				null, Messages.getString("uibk.applets.statistik.messages",
						"PanelDef.11"));
		quant[0].setText("0");
		quant[0].setActionCommand("quant1");
		quant[0].addActionListener(control);
		quant[0].setToolTipText(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.19"));

		quant[1] = new DoubleTextField(6, new Double(0.001), new Double(1),
				null, Messages.getString("uibk.applets.statistik.messages",
						"PanelDef.20"));
		quant[1].setText("0");
		quant[1].setActionCommand("quant2");
		quant[1].addActionListener(control);
		quant[1].setToolTipText(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.21"));

		quant[2] = new DoubleTextField(6, new Double(0.001), new Double(1),
				null, Messages.getString("uibk.applets.statistik.messages",
						"PanelDef.22"));
		quant[2].setText("0");
		quant[2].setActionCommand("quant3");
		quant[2].addActionListener(control);
		quant[2].setToolTipText(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.23"));

		quant[3] = new DoubleTextField(6, null, null, null, Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.52"));
		quant[3].setText("0");
		quant[3].setActionCommand("quant4");
		quant[3].addActionListener(control);
		quant[3].setToolTipText(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.53"));

		quant[4] = new DoubleTextField(6, null, null, null, Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.54"));
		quant[4].setText("0");
		quant[4].setActionCommand("quant5");
		quant[4].addActionListener(control);
		quant[4].setToolTipText(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.55"));

		quant[5] = new DoubleTextField(6, null, null, null, Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.58"));
		quant[5].setText("0");
		quant[5].setActionCommand("quant6");
		quant[5].addActionListener(control);
		quant[5].setToolTipText(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.59"));

		quant[6] = new DoubleTextField(6, null, null, null, Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.60"));
		quant[6].setText("0");
		quant[6].setActionCommand("quant7");
		quant[6].addActionListener(control);
		quant[6].setToolTipText(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.61"));

		quantil[0] = new JRadioButton(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelDef.12")); //$NON-NLS-1$
		quantil[0].setActionCommand("symm"); //$NON-NLS-1$
		quantil[0].addActionListener(control);
		quantil[0].setToolTipText(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelDef.14")); //$NON-NLS-1$
		quantil[0].setSelected(true);

		quantil[1] = new JRadioButton(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelDef.16")); //$NON-NLS-1$
		quantil[1].setActionCommand("asymm"); //$NON-NLS-1$
		quantil[1].addActionListener(control);
		quantil[1].setToolTipText(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelDef.18")); //$NON-NLS-1$

		quantil[2] = new JRadioButton(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelDef.50")); //$NON-NLS-1$
		quantil[2].setActionCommand("fenster"); //$NON-NLS-1$
		quantil[2].addActionListener(control);
		quantil[2].setToolTipText(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelDef.51")); //$NON-NLS-1$

		quantil[3] = new JRadioButton(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelDef.56")); //$NON-NLS-1$
		quantil[3].setActionCommand("fenstereins"); //$NON-NLS-1$
		quantil[3].addActionListener(control);
		quantil[3].setToolTipText(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelDef.57")); //$NON-NLS-1$

		ButtonGroup groupDerivateOpt = new ButtonGroup();
		groupDerivateOpt.add(quantil[0]);
		groupDerivateOpt.add(quantil[1]);
		groupDerivateOpt.add(quantil[1]);
		groupDerivateOpt.add(quantil[2]);
		groupDerivateOpt.add(quantil[3]);

		// Label fr Anzahl Gitterpunkte
		int n = AppletStatistik.GRIDDEFAULT;
		labelmesh = new JLabel(Messages.getString(AppletStatistik.BUNDLE_NAME,
				"PanelSurface.4") + n + "x" + n); //$NON-NLS-1$ //$NON-NLS-2$
		labelmesh.setFont(labelmesh.getFont().deriveFont(Font.BOLD));

		txtIntervaly = new IntervalTextField(10, Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelSurface.8"), //$NON-NLS-1$
				true);
		txtIntervaly.setActionCommand("compute"); //$NON-NLS-1$
		txtIntervaly.addActionListener(control);
		txtIntervaly.setToolTipText(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelSurface.10")); //$NON-NLS-1$

		txtIntervalx = new IntervalTextField(10, Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelSurface.11"), true); //$NON-NLS-1$
		txtIntervalx.setActionCommand("compute"); //$NON-NLS-1$
		txtIntervalx.addActionListener(control);
		txtIntervalx.setToolTipText(Messages.getString(
				AppletStatistik.BUNDLE_NAME, "PanelSurface.13")); //$NON-NLS-1$

		// Slider f?r Gitter
		sliderMeshPoints = new JSlider();
		sliderMeshPoints.addChangeListener(new ChangeListener() {

			public void stateChanged(ChangeEvent evt) {
				// aktuelle Gr??e im Label labelmesh ausgeben
				JSlider slider = (JSlider) evt.getSource();
				int n = slider.getValue();
				labelmesh
						.setText(Messages.getString(
								AppletStatistik.BUNDLE_NAME, "PanelSurface.19") + ": " + String.valueOf(n) //$NON-NLS-1$
								+ "x" + String.valueOf(n)); //$NON-NLS-1$
			}
		});
		// Wertebereich des Sliders einstellen
		sliderMeshPoints.setMinimum(AppletStatistik.GRIDMIN);
		sliderMeshPoints.setMaximum(AppletStatistik.GRIDMAX);
		sliderMeshPoints.setValue(AppletStatistik.GRIDDEFAULT);

		panelDarstel.add(labelmesh, new GridBagConstraints(0, 1, 2, 1, 1.0,
				0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(10, 5, 10, 5), 0, 0));
		panelDarstel.add(sliderMeshPoints, new GridBagConstraints(0, 2, 2, 1,
				1.0, 0.0, GridBagConstraints.WEST,
				GridBagConstraints.HORIZONTAL, new Insets(0, 5, 20, 5), 0, 0));
		panelDarstel.add(xAchse, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0, //$NON-NLS-1$
				GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0,
						5, 5, 0), 0, 0));
		panelDarstel.add(txtIntervalx, new GridBagConstraints(1, 3, 1, 1, 0.5,
				0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(0, 0, 5, 5), 0, 0));

		panelDarstel.add(yAchse, new GridBagConstraints(0, 4, 1, 1, 0.1, 0.0, //$NON-NLS-1$
				GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0,
						5, 5, 0), 0, 0));
		panelDarstel.add(txtIntervaly, new GridBagConstraints(1, 4, 1, 1, 0.5,
				0.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(0, 0, 15, 5), 0, 0));

		panelDarstel
				.add(quant[0], new GridBagConstraints(0, 1, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(quantil[0], new GridBagConstraints(0, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.WEST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel.add(labelquant[0], new GridBagConstraints(0, 3, 1, 1,
				0.0D, 0.0D, GridBagConstraints.CENTER, 0, new Insets(0, 100, 5,
						0), 0, 0));
		panelDarstel.add(labelquant[1], new GridBagConstraints(0, 4, 1, 1,
				0.0D, 0.0D, GridBagConstraints.CENTER, 0, new Insets(0, 100, 5,
						0), 0, 0));
		panelDarstel
				.add(quant[1], new GridBagConstraints(0, 3, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(quant[2], new GridBagConstraints(0, 4, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(quantil[1], new GridBagConstraints(0, 2, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.WEST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel.add(labelquant[2], new GridBagConstraints(0, 6, 1, 1,
				0.0D, 0.0D, GridBagConstraints.CENTER, 0, new Insets(0, 100, 5,
						0), 0, 0));
		panelDarstel.add(labelquant[3], new GridBagConstraints(0, 7, 1, 1,
				0.0D, 0.0D, GridBagConstraints.CENTER, 0, new Insets(0, 100, 5,
						0), 0, 0));
		panelDarstel
				.add(quant[3], new GridBagConstraints(0, 6, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(quant[4], new GridBagConstraints(0, 7, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(quantil[2], new GridBagConstraints(0, 5, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.WEST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel.add(labelquant[4], new GridBagConstraints(0, 6, 1, 1,
				0.0D, 0.0D, GridBagConstraints.CENTER, 0, new Insets(0, 100, 5,
						0), 0, 0));
		panelDarstel.add(labelquant[5], new GridBagConstraints(0, 7, 1, 1,
				0.0D, 0.0D, GridBagConstraints.CENTER, 0, new Insets(0, 100, 5,
						0), 0, 0));
		panelDarstel
				.add(quant[5], new GridBagConstraints(0, 6, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(quant[6], new GridBagConstraints(0, 7, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		panelDarstel
				.add(quantil[3], new GridBagConstraints(0, 5, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.WEST, 0, new Insets(0, 0, 5, 0), 0,
						0));

		panelDarstel.add(anz, new GridBagConstraints(1, 0, 1, 1, 0.0D, 0.0D,
				GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0, 0));
		panelDarstel
				.add(labelanz, new GridBagConstraints(0, 0, 1, 1, 0.0D, 0.0D,
						GridBagConstraints.EAST, 0, new Insets(0, 0, 5, 0), 0,
						0));
		main.symm = 2;
		visiblesymm();

		return panelDarstel;
	}

	public MPanel panelzeichnen() {
		MPanel panelzeichnen = new MPanel();
		panelzeichnen.setLayout(new GridLayout(1, 2, 30, 5));
		panelzeichnen.setMaximumSize(new Dimension(4000, 40));
		panelzeichnen.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));

		Button buttonStart = new Button(Messages.getString(
				"uibk.applets.statistik.messages", "PanelDef.30"));
		buttonStart.setActionCommand("zeichnen");
		buttonStart.addActionListener(control);
		panelzeichnen.add(buttonStart);
		return panelzeichnen;
	}

	private void visible(int konfig, boolean vis) {
		switch (konfig) {
		case 1:
			label[0][0].setVisible(vis);
			text[0].setVisible(vis);
			break;
		case 2:
			label[1][0].setVisible(vis);
			text[1].setVisible(vis);
			label[1][1].setVisible(vis);
			textint[4].setVisible(vis);
			break;
		case 3:
			label[2][0].setVisible(vis);
			text[2].setVisible(vis);
			break;
		case 4:
			label[3][0].setVisible(vis);
			label[3][1].setVisible(vis);
			text[3].setVisible(vis);
			text[4].setVisible(vis);
			break;
		case 5:
			label[4][0].setVisible(vis);
			text[5].setVisible(vis);
			break;
		case 6:
			label[5][0].setVisible(vis);
			label[5][1].setVisible(vis);
			label[5][2].setVisible(vis);
			text[6].setVisible(vis);
			text[7].setVisible(vis);
			text[8].setVisible(vis);
			break;
		case 7:
			label[6][0].setVisible(vis);
			label[6][1].setVisible(vis);
			text[9].setVisible(vis);
			text[10].setVisible(vis);
			break;
		case 8:
			label[7][0].setVisible(vis);
			textint[0].setVisible(vis);
			break;
		case 9:
			label[8][0].setVisible(vis);
			textint[1].setVisible(vis);
			break;
		case 10:
			label[9][0].setVisible(vis);
			label[9][1].setVisible(vis);
			textint[2].setVisible(vis);
			textint[3].setVisible(vis);
			break;

		default:
			break;
		}
	}

private void visiblesymm() {

		for (int i = 0; i < 7; i++) {
			quant[i].setVisible(false);
			quant[i].setEnabled(false);
		}
		for (int i = 0; i < 4; i++)
			quantil[i].setVisible(false);
		for (int i = 0; i < 6; i++)
			labelquant[i].setVisible(false);
		anz.setVisible(false);
		labelanz.setVisible(false);
		labelmesh.setVisible(false);
		sliderMeshPoints.setVisible(false);
		txtIntervalx.setVisible(false);
		txtIntervaly.setVisible(false);
		xAchse.setVisible(false);
		yAchse.setVisible(false);

		switch (main.symm) {
		case 2:
			break;
		case 1:
			for (int i = 0; i < 5; i++) {
				quant[i].setVisible(true);
			}
			quant[0].setEnabled(true);
			for (int i = 0; i < 3; i++)
				quantil[i].setVisible(true);
			for (int i = 0; i < 4; i++)
				labelquant[i].setVisible(true);
			quantil[0].setText(Messages.getString(
					"uibk.applets.statistik.messages", "PanelDef.12"));
			quantil[0].setToolTipText(Messages.getString(
					AppletStatistik.BUNDLE_NAME, "PanelDef.14")); //$NON-NLS-1$
			quantil[0].setSelected(true);
			break;
		case 3:
			anz.setVisible(true);
			labelanz.setVisible(true);
			break;
		case 4:
			quant[0].setEnabled(true);
			quant[0].setVisible(true);
			quant[5].setVisible(true);
			quant[6].setVisible(true);
			quantil[0].setVisible(true);
			quantil[3].setVisible(true);
			labelquant[4].setVisible(true);
			labelquant[5].setVisible(true);
			quantil[0].setText(Messages.getString(
					"uibk.applets.statistik.messages", "PanelDef.13"));
			quantil[0].setToolTipText(Messages.getString(
					AppletStatistik.BUNDLE_NAME, "PanelDef.15")); //$NON-NLS-1$
			quantil[0].setSelected(true);
			quantil[3].setText(Messages.getString(
					"uibk.applets.statistik.messages", "PanelDef.57"));
			break;
		case 5:
			labelmesh.setVisible(true);
			sliderMeshPoints.setVisible(true);
			txtIntervalx.setVisible(true);
			txtIntervaly.setVisible(true);
			xAchse.setVisible(true);
			yAchse.setVisible(true);
			break;
		case 6:
			quant[5].setVisible(true);
			quantil[0].setVisible(true);
			quantil[0].setSelected(true);
			quantil[0].setText(Messages.getString(
					"uibk.applets.statistik.messages", "PanelDef.79"));
			quantil[3].setVisible(true);
			labelquant[4].setVisible(true);
			quantil[3].setText(Messages.getString(
					"uibk.applets.statistik.messages", "PanelDef.77"));
			quantil[3].setToolTipText(Messages.getString(
					AppletStatistik.BUNDLE_NAME, "PanelDef.78")); //$NON-NLS-1$
			break;
		default:
			break;
		}
	}}
