package uibk.applets.statistik;

import uibk.mtk.draw2d.objects.GraphSequence;
import uibk.mtk.draw2d.util.GraphUtil;
import uibk.mtk.draw3d.objects.surface3d.Function2DMeshBuilder;
import uibk.mtk.draw3d.objects.surface3d.Mesh;
import uibk.mtk.geom.geom2d.CoordinateRect2D;
import uibk.mtk.geom.geom2d.Punkt2D;
import uibk.mtk.geom.geom3d.CoordinateBox3D;
import uibk.mtk.lang.InputException;
import uibk.mtk.lang.Messages;

import uibk.mtk.math.Interval;
import uibk.mtk.math.Sequence;
import uibk.mtk.math.functions.Function1D;
import uibk.mtk.math.functions.Function2D;
import uibk.mtk.math.integration.GaussIntegration;

import uibk.mtk.math.parsing.Function1DParser;
import uibk.mtk.math.parsing.Function2DParser;
import uibk.mtk.math.parsing.Misc;

import java.awt.*;
import java.util.*;
import javax.swing.JRadioButton;
import Jama.util.Maths;

public class Statistik {

	/** Verknpfung mit Main */
	AppletStatistik main;

	/** die Daten der Eingabe der Parameter der Schwingung */
	Boolean[] positiv;

	static final String VAR = "x";

	static final String VARy = "y";

	public Statistik(AppletStatistik main) {
		this.main = main;
		positiv = (new Boolean[] { null, null, Boolean.TRUE, Boolean.TRUE,
				Boolean.TRUE, Boolean.TRUE, Boolean.TRUE, Boolean.TRUE, null,
				null, Boolean.TRUE });
	}

	/** Lscht die Punkte des Graphen die ber ymax gehen */
	public void delete(Function1D func) {
		double a = main.bereich.ymax;
		boolean first=true;
		boolean last=false;
		int m=0;
		Vector points = main.graph.getPoints();
		int size=points.size();
		Punkt2D point;
		for (int i = 0; i < size; i++) {
			point = (Punkt2D) points.get(m);
			if (point.y > a){
				if(first&&main.verteilung==7){
					if (m>1) {
						m=addpoints(func,m-1,-1);
						points.insertElementAt(null,m);
						m++;
						first=false;
						last=true;
					} else {
						points.insertElementAt(new Punkt2D(0,a),1);
						points.insertElementAt(null,2);
						m+=2;
						first=false;
						last=true;
					}
				}
				if(first&&main.verteilung!=7){
					if (m!=0) {
						m=addpoints(func,m-1,-1);
						points.insertElementAt(null,m);
						m++;
						first=false;
						last=true;
					}else{
						first=false;
					}
				}
				points.removeElementAt(m);
			}else{
				if (last&&main.graph.getNumberPoints()!=m) {
					m=addpoints(func,m,1);
					last = false;
				}
			
				m++;
			}
			
		}
		points.trimToSize();
		main.graph.setPoints(points);
	}
	
	/** Fgt Punkte bei Singularitten hinzu bis die Darstellungsgrenze erreich ist*/
	public int addpoints(Function1D func,int n,int vor) {
		double a = main.bereich.ymax;
		double b = main.bereich.xmin;
		double c = main.bereich.xmax;
		Vector points = main.graph.getPoints();
			Punkt2D[] point=new Punkt2D[3];
			point[0] = (Punkt2D) points.get(n);
			double m;
			point[1] = (Punkt2D) points.get(n+vor);
			m=(point[1].x-point[0].x)/30;
			point[2] =new Punkt2D();
			point[2].x= point[0].x-m;
			point[2].y= func.getValue(point[2].x);
			int i=2;
			double lambda=0.5;
			while (point[2].y<a&&point[2].x>b&&point[2].x<c&&point[2].y!=0) {
				n=vor==-1?n+1:n;
			points.insertElementAt(point[2],n);
			points.trimToSize();
			point[2]=new Punkt2D();
			point[2].x= point[0].x-i*m;
			point[2].y= func.getValue(point[2].x);
			i++;
		}
			point[2]=new Punkt2D();
			point[0]=(Punkt2D)points.get(n);
			point[2].x= point[0].x-m*lambda;
			point[2].y= func.getValue(point[2].x);
			while (Math.abs(point[2].y-a)>1E-6) {
				if (point[2].y-a<0&&point[2].x>b&&point[2].x<c) {
					n=vor==-1?n+1:n;
					points.insertElementAt(point[2],n);
					point[2]=new Punkt2D();
					point[2]=(Punkt2D) points.get(n);
				}	
			if ((a-point[2].y)>=0&&m/2*lambda<point[2].x-b) {
				lambda/=2;
				point[2].x= point[2].x-m*lambda;
			}else{
				lambda/=2;
				point[2].x= point[2].x+m*lambda;
			}
			point[2].y= func.getValue(point[2].x);
			}
			if (lambda<0.5) {
				n=vor==-1?n+1:n;
				points.insertElementAt(point[2],n);
			}
			points.trimToSize();
		main.graph.setPoints(points);
		return n+1;
	}
	
	/** Fgt Punkte bei Singularitten hinzu bis die Darstellungsgrenze erreich ist*/
	public void add(Function1D func) {
			addpoints(func,0,1);
			int length=main.graph.getNumberPoints();
			addpoints(func,length-1,-1);
	}

	/** Liest die Daten der Textfelder der Parameter ein */
	public double get(int i) throws InputException {

		Double[] right = { new Double(1), new Double(1), null, null, null,
				null, null, null, new Double(1), null, null };

		Double[] left = { new Double(0), new Double(0), null, null, null, null,
				null, null, new Double(0), null, null };

		try {

			String strfunc = main.paneldefverteilung.text[i].getText();
			return Misc.parseDoubleValue(strfunc, Messages.getString(
					"uibk.applets.statistik.messages", "PanelDef."
							.concat(Integer.toString(39 + i))), left[i],
					right[i], positiv[i]);
		} catch (Exception e) {
			main.mathpanel2d.reportError(e);
			throw new InputException();
		}
	}

	/** Liest die Daten der Textfelder der Parameter ein */
	public double getquant(int i) throws InputException {

		Double[] left = { new Double(1E-8), new Double(1E-8), new Double(1E-8),
				null, null, null, null };

		Double[] right = { new Double(1 - 1E-8), new Double(1 - 1E-8),
				new Double(1 - 1E-8), null, null, null, null };
		Boolean[] pos = (new Boolean[] { null, null, null, Boolean.TRUE,
				Boolean.TRUE, Boolean.TRUE, Boolean.TRUE });
		try {

			String strfunc = main.paneldefverteilung.quant[i].getText();
			return Misc.parseDoubleValue(strfunc, Messages.getString(
					"uibk.applets.statistik.messages", "PanelDef."
							.concat(Integer.toString(70 + i))), left[i],
					right[i], pos[i]);
		} catch (Exception e) {
			main.mathpanel2d.reportError(e);
			throw new InputException();
		}
	}

	/** Liest die Daten der Textfelder der Parameter ein */
	public int getintt(int i) throws InputException {
		try {
			String strfunc = main.paneldefverteilung.textint[i].getText();
			return Misc.parseIntegerValue(strfunc, Messages.getString(
					"uibk.applets.statistik.messages", "PanelDef."
							.concat(Integer.toString(24 + i))), new Integer(1),
					new Integer(150));
		} catch (Exception e) {
			main.mathpanel2d.reportError(e);
			throw new InputException();
		}
	}

	/** Liest die Daten der Textfelder der Parameter ein */
	public int getint() throws InputException {
		try {
			String strfunc = main.paneldefverteilung.anz.getText();
			return Misc.parseIntegerValue(strfunc, Messages.getString(
					"uibk.applets.statistik.messages", "PanelDef.29"),
					new Integer(1), new Integer(150));
		} catch (Exception e) {
			main.mathpanel2d.reportError(e);
			throw new InputException();
		}
	}

	/**
	 * Setzt je nach Auswahl der kontinuierlichen Verteilung die explizite
	 * Formel der Verteilung
	 */
	public Function1D getkont() throws Exception {
		Function1D f;
		String funktion = new String();
		double sigma = 1;
		double n = 1;
		switch (main.verteilung) {
		case 4:
			double alpha;
			double beta;
			alpha = get(3);
			beta = get(4);
			funktion = new String(Double.toString(1 / Maths.beta(alpha, beta))
					.concat("*x^(").concat(Double.toString(alpha - 1)).concat(
							")*(1-x)^(").concat(Double.toString(beta - 1))
					.concat(")"));
			break;
		case 5:
			sigma = get(5);
			funktion = new String(Double.toString(
					1 / (Math.sqrt(2 * Math.PI) * sigma)).concat("*exp(-x^2/(")
					.concat(Double.toString(2 * Math.pow(sigma, 2))).concat(
							"))"));
			break;

		case 7:
			double m;
			m = get(9);
			sigma = get(10);
			funktion = new String(Double.toString(
					1 / (Math.sqrt(2 * Math.PI) * sigma)).concat(
					"*1/x*exp(-((log(x)-").concat(
					Double.toString(m).concat(")/")).concat(
					Double.toString(sigma)).concat(")^2/2)"));
			break;
		case 8:
			n = getintt(0);
			funktion = new String(Double.toString(
					1 / (Math.pow(2, n / 2) * Maths.gamma(n / 2))).concat(
					"*x^(").concat(Double.toString(n / 2 - 1)).concat(
					")*exp(-x/2)"));
			break;
		case 9:
			n = getintt(1);
			funktion = new String(Double.toString(
					Maths.gamma((n + 1) / 2)
							/ (Maths.gamma(n / 2) * Math.sqrt(Math.PI * n)))
					.concat("*(1+x^2/").concat(Double.toString(n))
					.concat(")^(").concat(Double.toString(-(1 + n) / 2))
					.concat(")"));
			break;
		case 10:
			n = getintt(2);
			double m = getintt(3);
			funktion = new String(Double.toString(Math.pow(m / n, m / 2))
					.concat("*x^(").concat(Double.toString(-1 + m / 2)).concat(
							")*(1+x*").concat(Double.toString(m / n)).concat(
							")^(").concat(Double.toString(-(m + n) / 2))
					.concat(")/").concat(
							Double.toString(Maths.beta(m / 2, n / 2))));
			break;
		default:
			break;
		}
		f = Function1DParser.parse(VAR, funktion);
		return f;
	}

	/** Setzt die Funktionen fr zweidimensionale Verteilungen */
	public Function2D getkont2D() throws Exception {
		Function2D f;
		double sigma1;
		double sigma2;
		double korr;
		sigma1 = get(6);
		sigma2 = get(7);
		korr = get(8);
		String funktion = new String(Double.toString(
				1 / (2 * Math.PI * sigma1 * sigma2 * Math.sqrt(1 - Math.pow(
						korr, 2)))).concat("*exp(").concat(
				Double.toString(-1 / (1 - Math.pow(korr, 2)))).concat(
				"*(x^(2)/(2*").concat(Double.toString(sigma1 * sigma1)).concat(
				")-x*y*").concat(Double.toString(korr / (sigma1 * sigma2)))
				.concat("+y^2/2*").concat(
						Double.toString(1 / (sigma2 * sigma2))).concat("))"));
		f = Function2DParser.parse(VAR, VARy, funktion);
		return f;
	}

	/** Zeichnet die eindimensionale Verteilung */
	public void calcplotkont2dim(Function1D func, double start, double end)
			throws Exception {

		switch (main.verteilung) {
		case 4:
			double a = main.paneldefverteilung.text[3].getValue();
			double b = main.paneldefverteilung.text[4].getValue();
			if (a < 1 || b < 1) {
				if (a < 1 && b < 1) {
					start += 0.001;
					end -= 0.001;
					Vector graphen = new Vector();
					graphen.addAll(GraphUtil.compute(func, start, end, 400));
					main.graph.setPoints(graphen);
					if (!main.paneldefverteilung.quantil[3].isSelected()) {
						main.bereich = main.graph.getLimits();
						if (main.graph.getFirstPoint().y>main.graph.getLastPoint().y) {
							main.bereich.ymax=main.graph.getFirstPoint().y;
						}else{
							main.bereich.ymax=main.graph.getLastPoint().y;
						}
						main.bereich.xmax = 1;
						main.bereich.xmin = 0;
					} else
						delete(func);

					break;
				} else {
					if (a < 1) {
						start = 0.001;
						Vector graphen = new Vector();
						graphen
								.addAll(GraphUtil
										.compute(func, start, end, 400));
						main.graph.setPoints(graphen);
					}
					if (b < 1) {
						end -= 0.001;
						Vector graphen = new Vector();
						graphen
								.addAll(GraphUtil
										.compute(func, start, end, 400));
						main.graph.setPoints(graphen);
					}
						if (!main.paneldefverteilung.quantil[3].isSelected()) {
							main.bereich = main.graph.getLimits();
							main.bereich.xmin = 0;
						} else
							delete(func);
						break;
				}
			}
			Vector graphen = new Vector();
			graphen.addAll(GraphUtil.compute(func, start, end, 400));
			main.graph.setPoints(graphen);
			if (!main.paneldefverteilung.quantil[3].isSelected()) {
				main.bereich = main.graph.getLimits();
			} else
				delete(func);
			break;
		case 7:
			start = 0.001;
			graphen = new Vector();
			graphen.add(new Punkt2D(0, 0));
			graphen.addAll(GraphUtil.compute(func, start, end, 400));
			main.graph.setPoints(graphen);
			main.bereich = main.graph.getLimits();
			if (main.paneldefverteilung.quantil[3].isSelected()) {
				main.bereich.ymax = getquant(6);
				main.bereich.ymin = 0;
				delete(func);
			}
			break;
		case 8:
			if (getintt(0) == 1) {
				start = 0.001;
				graphen = new Vector();
				graphen.addAll(GraphUtil.compute(func, start, end, 400));
				main.graph.setPoints(graphen);
				main.bereich = main.graph.getLimits();
				main.bereich.xmin = 0;
				main.bereich.ymin = 0;
			} else {
				graphen = new Vector();
				graphen.addAll(GraphUtil.compute(func, start, end, 400));
				main.graph.setPoints(graphen);
				main.bereich = main.graph.getLimits();
			}
			if (main.paneldefverteilung.quantil[3].isSelected()) {
				main.bereich.ymax = getquant(6);
				main.bereich.ymin = 0;
				delete(func);
			}
			break;
		case 10:
			if (getintt(3) == 1) {
				start = 0.001;
				graphen = new Vector();
				graphen.addAll(GraphUtil.compute(func, start, end, 400));
				main.graph.setPoints(graphen);
				main.bereich = main.graph.getLimits();
				main.bereich.xmin = 0;
				main.bereich.ymin = 0;
			} else {
				graphen = new Vector();
				graphen.addAll(GraphUtil.compute(func, start, end, 400));
				main.graph.setPoints(graphen);
				main.bereich = main.graph.getLimits();
			}
			if (main.paneldefverteilung.quantil[3].isSelected()) {
				main.bereich.ymax = getquant(6);
				main.bereich.ymin = 0;
				delete(func);
			}
			break;
		case 5:
		case 9:
			main.graph.setPoints(GraphUtil.compute(func, start, end, 400));
			main.bereich = main.graph.getLimits();
			if (main.paneldefverteilung.quantil[2].isSelected()) {
				main.bereich.ymax = getquant(4);
				main.bereich.ymin = 0;
				delete(func);
			}
			break;

		default:
			break;
		}
		main.mathpanel2d.getScene2d().setLimits(main.bereich);

		// Meldung ber Erfolg und neu zeichnen
		if (main.ende != 30) {
			main.mathpanel2d.reportSuccess(func
					+ " "
					+ Messages.getString(AppletStatistik.BUNDLE_NAME,
							"PanelSurface.1")); //$NON-NLS-1$
		}
		main.mathpanel2d.repaint();
	}

	/** Liefert die Grenzen der Darstellung je nach Quantile */
	public void getlimits(Function1D func) throws Exception {
		double left;
		double right;
		JRadioButton[] quantil = main.paneldefverteilung.quantil;
		if ((quantil[2].isSelected() && quantil[2].isVisible())
				|| (quantil[3].isSelected() && quantil[3].isVisible())) {
			if (quantil[2].isSelected()) {
				double a, b;
				a = getquant(3);
				b = getquant(4);
				main.bereich = new CoordinateRect2D(-a, a, 0, b);
				main.start = -a;
				main.ende = a;
			} else {
				if (main.symm == 6) {
					double a;
					a = getquant(5);
					main.bereich = new CoordinateRect2D(0, 1, 0, a);
					main.start = 0;
					main.ende = 1;
				} else {
					double a, b;
					a = getquant(5);
					b = getquant(6);
					main.bereich = new CoordinateRect2D(0, a, 0, b);
					main.start = 0;
					main.ende = a;
				}
			}
		} else {
			if (main.symm == 4) {
				left = getquant(0);
				main.start = 0;
				main.ende = this.bisektion(func, left);
			}
			if (main.symm == 1) {
				if (main.paneldefverteilung.quantil[0].isSelected()) {
					left = getquant(0);
					main.start = -this.bisektion(func, left / 2);
					main.ende = -main.start;
				} else {
					left = getquant(1);
					right = getquant(2);
					if (main.symm == 1 && left > right
							&& main.paneldefverteilung.quantil[1].isEnabled()) {
						main.mathpanel2d.reportError(Messages.getString(
								"uibk.applets.statistik.messages",
								"InteractionControl.3"));
						throw new InputException();
					}
					if (left >= 0.5) {
						main.start = this.bisektion(func, left - 0.5);
						main.ende = this.bisektion(func, right - 0.5);
					}
					if (left < 0.5 && right >= 0.5) {
						main.start = -this.bisektion(func, 0.5 - left);
						main.ende = this.bisektion(func, right - 0.5);
					}
					if (right < 0.5 && left < 0.5) {
						main.start = -this.bisektion(func, 0.5 - left);
						main.ende = -this.bisektion(func, 0.5 - right);
					}
				}
			}
			if (main.verteilung == 4) {
				main.start = 0;
				main.ende = 1;

			}
			if (Double.isNaN(main.ende)) {
				main.ende = 30;
				main.mathpanel2d
						.reportError("Quantile konnte nicht berechnet werden "
								+ "deshalb wurde [0,30] dargestellt");
			}
		}
		return;
	}

	/** Zeichnet die zweidimensionale Verteilung */
	public void calcplotkont3dim(Function2D func) throws Exception {
		// Koordinatengrenzen
		Interval cordx = main.paneldefverteilung.txtIntervalx.getInterval();
		Interval cordy = main.paneldefverteilung.txtIntervaly.getInterval();
		CoordinateRect2D limits = new CoordinateRect2D(cordx.a, cordx.b,
				cordy.a, cordy.b);
		int n = main.paneldefverteilung.sliderMeshPoints.getValue();
		try {
			// Versuchen das Gitter zu berechnen
			Function2DMeshBuilder meshbuilder = new Function2DMeshBuilder(func);
			Mesh mesh = meshbuilder.build(limits, n, n, true);
			main.surface3d.setMesh(mesh);

		} catch (Exception e) {
			// Flche unsichtbar
			main.surface3d.setVisible(false);
			// Standardkoordinatengrenzen setzen
			main.mathpanel3d.getScene3D().setBoundingBox(new CoordinateBox3D());
			// Ausgabe der Fehlermeldung
			main.mathpanel3d.reportError(e);
			throw new Exception(Messages.getString(AppletStatistik.BUNDLE_NAME,
					"NewtonVisualisation.1")); //$NON-NLS-1$
		}

		// Grenzen der Fl?che
		CoordinateBox3D box = main.surface3d.getBoundingBox();

		// Grenzen setzen
		main.mathpanel3d.getScene3D().setBoundingBox(box);

		// Flche sichtbar
		main.surface3d.setVisible(true);

		// Meldung ber Erfolg und neu zeichnen
		main.mathpanel3d.reportSuccess(func
				+ " "
				+ Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelSurface.1")); //$NON-NLS-1$
		main.mathpanel3d.repaint();

	}

	/** Zeichnet die diskrete Verteilung */
	public void calcplotdiskret(double[] initials, int start, int end)
			throws Exception {
		Sequence sequence;
		double n=0;
		double[] seq = null;
		switch (main.verteilung) {

		case 1:
			n = get(0);
			main.paneldefverteilung.disk = new String(Double.toString(n)
					.concat("*(1-").concat(Double.toString(n))
					.concat(")^(n)"));
			break;
		case 2:
			int m;
			n = get(1);
			m = getintt(4);
			main.paneldefverteilung.disk = new String(Integer.toString(m)
					.concat("!/(n!*(").concat(Integer.toString(m)).concat(
							"-n)!)*").concat(Double.toString(n)).concat(
							"^n*(1-").concat(Double.toString(n)).concat(")^(")
					.concat(Integer.toString(m)).concat("-n)"));
			break;
		case 3:
			n = get(2);
			main.paneldefverteilung.disk = new String(Double.toString(n)
					.concat("^n/n!*exp(").concat(Double.toString(-n)).concat(
							")"));
			break;
		default:
			break;
		}

		// Folge einlesen und berechnen
		sequence = main.sequenceparser.parse(main.paneldefverteilung.disk, "n"); //$NON-NLS-1$
		if (main.verteilung != 2) {
			seq = sequence.compute(null, main.paneldefverteilung.start,
					main.paneldefverteilung.anz.getValue());
		} else {
			seq = sequence.compute(null, main.paneldefverteilung.start,
					main.stat.getintt(4));
		}
		main.graphdiskret.clear();
		// Graph erzeugen
		GraphSequence graph = new GraphSequence();
		// Formel setzen (fr Tooltips)
		graph.setFormula(sequence.getFormula());
		// zu den anderen hinzufgen
		graph.connectPoints(false);
		graph.columns(true);
		graph.setColor(Color.BLUE);
		graph.setPointRadius(3);
		main.graphdiskret.addGraph(graph);
		main.graphdiskret.setVisible(true);
		// Folge setzen
		graph.setSequence(seq, start, end);

		// Farben fr den Graph setzen
		graph.setLineColor(Color.blue);
		graph.setColor(Color.black);
		graph.setVisible(true);

		// Achsen sichtbar
		main.axes.setVisible(true);
		// Grenzen des Graphs
		CoordinateRect2D limits = graph.getLimits();
		limits.ymin = 0;
		limits.ymax = limits.ymax * 1.05;
		this.main.mathpanel2d.getScene2d().setLimits(limits);

		// Meldung ber Erfolg und neu zeichnen
		main.mathpanel2d.reportSuccess(main.paneldefverteilung.disk
				+ " "
				+ Messages.getString(AppletStatistik.BUNDLE_NAME,
						"PanelSurface.1")); //$NON-NLS-1$
		main.mathpanel2d.repaint();

	}

	/** Liefert die Grenzen mit der Bisektionsmethode */
	public double bisektion(Function1D func, double bereich) throws Exception {
		int steps = 1000;
		int stufe = 8;
		double x = 0.9;
		double sum = 0;
		double sumx1 = 0;
		double x1 = 0;
		double x2 = 0;
		double xold,xnew;
		GaussIntegration integrate = new GaussIntegration();
		double integral=integrate.quadrature(func, 0, x, stufe, steps);
		sum = bereich - integral;
		sumx1=sum;
		while (sum >= 0) {
			x*=2;
			if (sum<1E-2) {
				steps=50;
			}else{
				steps=1000;
			}
			integral+=integrate.quadrature(func, x/2, x, stufe, steps);
			sum = bereich - integral;
			if (sum>sumx1){
				main.mathpanel2d.reportError(Messages.getString("uibk.applets.statistik.messages",
				"InteractionControl.4"));
				throw new Exception();
			}
			sumx1=sum;
		}
		x1 = 0;
		x2 = x;
		xold=x2;
		xnew=(x2+x1)/2;
		while (Math.abs(sum) > 1E-7) {
			if (sum<1E-2) {
				steps=50;
			}else{
				steps=1000;
			}

				xnew = (x2 + x1) / 2;
				if (xnew<xold) {
					integral-=integrate.quadrature(func, xnew, xold, stufe, steps);
				} else {
					integral+=integrate.quadrature(func, xold,xnew, stufe, steps);
				}

				xold=xnew;
			sum = bereich-integral;
			if (sum <= 0) {
				x2=xnew;
			}else{
				x1=xnew;
			}
		}

		return xold;
	}
}
