package uibk.mtk.draw2d.base;

import uibk.mtk.lang.Drawable;

/**
 * Ein Drawable2D Objekt ist ein Objekt in der Ebene, das gezeichnet werden
 * kann. Es kann zu einem <CODE>MathPanel2D</CODE> hinzugef?gt werden welcher
 * wiederum eine <CODE>Scene2D</CODE> enth?lt, in dem sich die Drawable2D
 * Objekte "befinden". Falls ein Drawable2D Objekt aufwendigere Berechnungen
 * durchf?hren muss, sollte es das Interface <CODE>PrepaintComputable</CODE>
 * implementieren. (Die Funktion prepaintcompute() des Interface wird vom dem
 * <CODE>Mathpanel2D</CODE>, in dem sich das Drawable befindet vor dem
 * Zeichnen aufgerufen (falls sich irgendetwas ge?ndert hat, wie z.B. die
 * Fenstergr??e)
 * 
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public abstract class Drawable2D extends Drawable {

	/**
	 * die Szene, in dem sich das Drawable befindet. Diese Variable wird von der
	 * Funktion setMathPanel2D auf das zum MathPanel2D geh?rende
	 * Koordinatensystem gesetzt
	 */
	protected Scene2D scene2d = null;

	/**
	 * Das verwaltende Mathpanel2DObjekt in dem sich das Drawable befindet.
	 * Diese Variable wird ?ber die Funktion <CODE>setMathPanel2D <CODE>
	 * gesetzt, sobald das <CODE>Drawable2D</CODE> zu einem <CODE>MathPanel2D
	 * </CODE> hinzugef?gt wird.
	 */
	protected MathPanel2D panel = null;

	/**
	 * Setzt die Membervariable <CODE>panel</CODE>, also das MathPanel2D
	 * Objekt in dem das Drawable-Objekt gezeichnet wird und die Variable <CODE>
	 * scene2d</CODE> auf die zu dem MathPanel2D geh?rende <CODE>Scene2D
	 * </CODE>
	 */
	public void setMathPanel2D(MathPanel2D panel) {
		this.panel = panel;
		this.scene2d = panel.getScene2d();
	}

}