package uibk.mtk.draw2d.objects;

import java.awt.event.MouseEvent;

import uibk.mtk.lang.ToolTipable;

/**
 * Container f?r mehrere Graphen vom Typ GraphSequnce2D. Diese Zusammenfassung
 * von Folgengraphen zeigt die Tooltips, der Punkte des jeweiligen Graphen an.
 * (falls Tooltips aktiviert sind)
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class MutltiTooltipableGraph extends MultiGraph2D implements ToolTipable {

	/** Anzeige der Tooltips */
	boolean tooltipenabled = true;

	/** gibt zur?ck ob Tooltips angezeigt werden */
	public boolean isToolTipEnabled() {
		return this.tooltipenabled;
	}

	/** (de)aktiviert die Tooltips */
	public void enableToolTip(boolean b) {
		this.tooltipenabled = b;
	}

	/** Implementierung f?r das Interface ToolTipable (wird nicht verwendet) */
	public void setToolTipText(String tooltip) {
	}

	/**
	 * Ist Maus im Tooltip bereich des Containers (wir geben einfach immer true
	 * zur?ck, da getToolTipText sowieso solange alle Graphen und alle Punkte
	 * durchprobieren muss, bis sie Punkt findet ?ber dem die Maus ist, und
	 * falls Maus ?ber keinem Punkt null zur?ckgibt
	 */
	public boolean tooltipcontains(int x, int y) {
		return true;
	}

	/** gibt den Tooltip des Punktes zur?ck, ?ber den die Maus sich befindet */
	public String getToolTipText(MouseEvent ev) {
		String tooltip;
		for (int i = 0; i < graphs.size(); i++) {

			tooltip = ((GraphSequence) graphs.elementAt(i)).getToolTipText(ev);
			if (tooltip != null)
				return tooltip;
		}

		return null;
	}

}