package uibk.mtk.draw3d.base;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import uibk.mtk.draw3d.rasterizer.Rasterizer;

/**
 * Ein <CODE>Rasterable3D</CODE> ist ein <CODE>Drawable3D</CODE>, das zum
 * Zeichnen die Klasse Rasterkonvertierungen durchf?hren will (z.b. Fl?che ->
 * F?llen der Dreiecke). Ein <CODE>Rasterable3D</CODE> muss zu einem <CODE>
 * RMathPanel3D</CODE> hinzugef?gt werden.
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public abstract class Rasterable3D extends Drawable3D {

	/**
	 * Klasse f?r Rasterkonvertierung die zum Zeichnen des Objekts verwendet
	 * werden kann
	 */
	protected Rasterizer rasterizer;

	/**
	 * Setzen des <CODE>Rasterizer</CODE>, wird vom <CODE>RMathPanel3D
	 * </CODE> beim Hinzuf?gen des Objekts aufgerufen
	 */
	public void setRasterizer(Rasterizer rasterizer) {
		this.rasterizer = rasterizer;
	}

	/** Zeichnen des Objekts */

	public abstract void draw(BufferedImage framebuffer, Graphics2D g2);
}