package uibk.mtk.draw3d.objects.surface3d;

import java.util.Iterator;

import uibk.mtk.geom.geom3d.CoordinateBox3D;

/**
 * Ein Farbmodell.
 * 
 * <p>
 * Farbmodell zum Setzen der Farben von Vertices die ?ber einen <CODE>Iterator
 * </CODE> abgerufen werden.
 * </p>
 * 
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public abstract class ColorModel {

	/**
	 * Funktion zur Berechnung der Farben
	 * 
	 * @param it
	 *            Iterator ?ber Vertex3D Objekte
	 * @param box
	 *            BoundingBox (d.h. minimale und maximale Koordinaten) der
	 *            Vertice die mit dem Iterator abgelaufen werden.)
	 */
	public abstract void colorVertices(Iterator it, CoordinateBox3D box);
}