package uibk.mtk.geom.geom3d;

/**
 * Ein Vektor im Raum gegeben durch x,y,z Koordinaten in doppelter Genauigkeit
 * 
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class Vector3D extends Punkt3D {

	/** Erzeugt den Vector3D mit den ?bergebenen Koordinaten */
	public Vector3D(double x1, double x2, double x3) {
		super(x1, x2, x3);
	}

	/** Erzeugt den Vector3D mit den Koordinaten (0,0,0) */
	public Vector3D() {
		super();
	}

	/**
	 * Copy-Konstrukor: erzeugt den einen Vektor mit den Koordinaten des
	 * ?bergebenen Vektors
	 */
	public Vector3D(Vector3D v) {
		this(v.x1, v.x2, v.x3);
	}

	/** Gibt das Kreuzprodukt zweier Vektoren zur?ck */
	public Vector3D crossProd(Vector3D b) {
		Vector3D c = new Vector3D();
		c.x1 = x2 * b.x3 - x3 * b.x2;
		c.x2 = x3 * b.x1 - x1 * b.x3;
		c.x3 = x1 * b.x2 - x2 * b.x1;

		return c;
	}

	/** Erstellt eine Kopie des Punktes */
	public Object clone() {
		return new Vector3D(x1, x2, x3);
	}

}