package uibk.mtk.lang;

import java.awt.event.MouseEvent;

/**
 * Interface f?r das Drawable Objekte implementieren k?nnen um Tooltips
 * anzuzeigen. (das Aufrugen der Tooltips wird in der Klasse
 * MathPanel3D/MathPanel2D vorgenommen)
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public interface ToolTipable {

	/** zum (de)aktivieren der Tooltips */
	void enableToolTip(boolean b);

	/** ist Tooltip aktiviert */
	boolean isToolTipEnabled();

	/** zum setzten des Tooltip Textes */
	void setToolTipText(String tip);

	/** gibt den Tooltiptext zur?ck (wird von mathpanel aufgerufen) */
	String getToolTipText(MouseEvent ev);

	/**
	 * gibt an ob Maus ?ber dem "Tooltipbereich" des Drawable ist oder nicht,
	 * d.h. ob der Tooltip angezeigt werden soll. (wird vom <CODE>MathPanel
	 * </CODE> aufgerufen)
	 */

	boolean tooltipcontains(int x, int y);

}