package uibk.mtk.swing.base;

import java.awt.Component;
import java.awt.LayoutManager;

import javax.swing.JPanel;

/**
 * Von JPanel abgeleitete Klasse, die alle Konstruktoren implementiert und die
 * Funktion <CODE>setEnabled(boolean)</CODE> so ?berschreibt, dass alle
 * Komponenten im Panel (de)aktiviert werden.
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2004
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class MPanel extends JPanel {

	/** siehe {@link javax.swing.JPanel#JPanel()} */
	public MPanel() {
		super();

	}

	/** siehe {@link javax.swing.JPanel#JPanel(boolean)} */
	public MPanel(boolean isDoubleBuffered) {
		super(isDoubleBuffered);

	}

	/** siehe {@link javax.swing.JPanel#JPanel(LayoutManager)} */
	public MPanel(LayoutManager layout) {
		super(layout);

	}

	/** siehe {@link javax.swing.JPanel#JPanel(LayoutManager,boolean)} */
	public MPanel(LayoutManager layout, boolean isDoubleBuffered) {
		super(layout, isDoubleBuffered);

	}

	/**
	 * ?berschreiben der Funktion <CODE>setEnabled(boolean)</CODE>, damit
	 * auch Komponenten im Panel (de)aktiviert werden und nicht nur der Panel
	 * selbst.
	 */
	public void setEnabled(boolean enabled) {
		super.setEnabled(enabled);

		Component[] comps = this.getComponents();
		for (int i = 0; i < comps.length; i++)
			comps[i].setEnabled(enabled);
	}

}