package uibk.mtk.swing.base;

import java.awt.Dimension;
import java.awt.event.ActionListener;

import javax.swing.JTextField;
import javax.swing.text.Document;

/**
 * Von <CODE>JTextField</CODE> abgeleitete Klasse, die alle Konstruktoren der
 * Superklasse und noch zwei weitere implementiert.
 * 
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class TextField extends JTextField {

	/** siehe {@link javax.swing.JTextField#JTextField()} */
	public TextField() {
		super();

	}

	/** siehe {@link javax.swing.JTextField#JTextField(int)} */
	public TextField(int columns) {
		super(columns);

	}

	/** siehe {@link javax.swing.JTextField#JTextField(String)} */
	public TextField(String text) {
		super(text);

	}

	/** siehe {@link javax.swing.JTextField#JTextField(String,int)} */
	public TextField(String text, int columns) {
		super(text, columns);

	}

	/** siehe {@link javax.swing.JTextField#JTextField(Document,String,int)} */
	public TextField(Document doc, String text, int columns) {
		super(doc, text, columns);

	}

	/**
	 * Erzeugt ein Textfeld
	 * 
	 * @param cols
	 *            Anzahl der Spalten
	 * @param actioncommand
	 *            actioncommand f?r das Textfeld
	 * @param listener
	 *            <CODE>ActionListener</CODE> f?r das Textfeld
	 * @param tooltip
	 *            <CODE>Tooltip</CODE> f?r das Textfeld
	 */
	public TextField(int cols, String actioncommand, ActionListener listener,
			String tooltip) {

		this(cols);
		setActionCommand(actioncommand);
		addActionListener(listener);
		setToolTipText(tooltip);
		setMinimumSize(getPreferredSize());

	}

	/**
	 * Erzeugt ein Textfeld
	 * 
	 * @param text
	 *            Text der im Feld steht
	 * @param cols
	 *            Anzahl der Spalten
	 * @param actioncommand
	 *            actioncommand f?r das Textfeld
	 * @param listener
	 *            <CODE>ActionListener</CODE> f?r das Textfeld
	 * @param tooltip
	 *            <CODE>Tooltip</CODE> f?r das Textfeld
	 */
	public TextField(String text, int cols, String actioncommand,
			ActionListener listener, String tooltip) {
		this(cols);
		setText(text);

		setActionCommand(actioncommand);
		addActionListener(listener);
		setToolTipText(tooltip);
		setMinimumSize(getPreferredSize());

	}

	/*
	 * Found the same solution in the bug database as 4188906. See also 4238932
	 * which gives a solution with a new class: Also relates to 4247013
	 */
	public Dimension getMinimumSize() {
		return getPreferredSize();
	}

}