package uibk.mtk.swing.base;

import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;

/**
 * <CODE>Panel</CODE> mit einem Rahmen und einem Titel.
 * 
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class TitledPanel extends MPanel {

	/**
	 * Erzeugt einen <CODE>Panel mit einem Rahmen und einem Titel
	 * 
	 * @param titel
	 *            Titel des Panels
	 */
	public TitledPanel(String titel) {
		super();
		//Rahmen mit Titel erzeugen
		TitledBorder border = BorderFactory.createTitledBorder(titel);
		border.setTitleFont(border.getTitleFont().deriveFont(Font.BOLD));
		setBorder(border);
	}

	/**
	 * Setzt den Titel des Panels
	 * 
	 * @param title
	 *            neuer Titel des Panel
	 */
	public void setBorderTitle(String title) {
		TitledBorder border = (TitledBorder) getBorder();
		border.setTitle(title);
	}

}